# SPDX-FileCopyrightText: 2024 Luca Weiss
# SPDX-License-Identifier: GPL-3.0-only

from gi.repository import GObject
from gi.repository import Gtk


@Gtk.Template(resource_path="/eu/lucaweiss/lpa-gtk/widgets/esimprofile.ui")
class ESimProfileWidget(Gtk.ListBoxRow):
    __gtype_name__ = "LpaGtkESimProfile"

    profile = None

    _title = ""
    @GObject.property(type=str, default="")
    def title(self):
        return self._title

    @title.setter
    def title(self, v):
        self._title = v

    _enabled = False
    @GObject.property(type=bool, default=False)
    def enabled(self):
        return self._enabled

    @enabled.setter
    def enabled(self, v):
        self._enabled = v
        self.notify("enabled-label")

    @GObject.Property(type=str, default="")
    def enabled_label(self):
        return _("Enabled") if self._enabled else _("Disabled")

    _provider = ""
    @GObject.property(type=str, default="")
    def provider(self):
        return self._provider

    @provider.setter
    def provider(self, v):
        self._provider = v
        self.notify("provider-label")

    @GObject.Property(type=str, default="")
    def provider_label(self):
        return _("Provider: %(provider)s") % {"provider": self._provider}

    _iccid = ""
    @GObject.property(type=str, default="")
    def iccid(self):
        return self._iccid

    @iccid.setter
    def iccid(self, v):
        self._iccid = v
        self.notify("iccid-label")

    @GObject.Property(type=str, default="")
    def iccid_label(self):
        return f"ICCID: {self._iccid}"
